<?php

namespace Pcm\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAlternateHosLocation ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAlternateHosLocation
 * @package Pcm
 * @subpackage Arrays
 */
class PcmArrayOfAlternateHosLocation extends AbstractStructArrayBase
{
    /**
     * The AlternateHosLocation
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmAlternateHosLocation[]
     */
    public $AlternateHosLocation;
    /**
     * Constructor method for ArrayOfAlternateHosLocation
     * @uses PcmArrayOfAlternateHosLocation::setAlternateHosLocation()
     * @param \Pcm\StructType\PcmAlternateHosLocation[] $alternateHosLocation
     */
    public function __construct(array $alternateHosLocation = array())
    {
        $this
            ->setAlternateHosLocation($alternateHosLocation);
    }
    /**
     * Get AlternateHosLocation value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmAlternateHosLocation[]|null
     */
    public function getAlternateHosLocation()
    {
        return isset($this->AlternateHosLocation) ? $this->AlternateHosLocation : null;
    }
    /**
     * Set AlternateHosLocation value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmAlternateHosLocation[] $alternateHosLocation
     * @return \Pcm\ArrayType\PcmArrayOfAlternateHosLocation
     */
    public function setAlternateHosLocation(array $alternateHosLocation = array())
    {
        foreach ($alternateHosLocation as $arrayOfAlternateHosLocationAlternateHosLocationItem) {
            // validation for constraint: itemType
            if (!$arrayOfAlternateHosLocationAlternateHosLocationItem instanceof \Pcm\StructType\PcmAlternateHosLocation) {
                throw new \InvalidArgumentException(sprintf('The AlternateHosLocation property can only contain items of \Pcm\StructType\PcmAlternateHosLocation, "%s" given', is_object($arrayOfAlternateHosLocationAlternateHosLocationItem) ? get_class($arrayOfAlternateHosLocationAlternateHosLocationItem) : gettype($arrayOfAlternateHosLocationAlternateHosLocationItem)), __LINE__);
            }
        }
        if (is_null($alternateHosLocation) || (is_array($alternateHosLocation) && empty($alternateHosLocation))) {
            unset($this->AlternateHosLocation);
        } else {
            $this->AlternateHosLocation = $alternateHosLocation;
        }
        return $this;
    }
    /**
     * Add item to AlternateHosLocation value
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmAlternateHosLocation $item
     * @return \Pcm\ArrayType\PcmArrayOfAlternateHosLocation
     */
    public function addToAlternateHosLocation(\Pcm\StructType\PcmAlternateHosLocation $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pcm\StructType\PcmAlternateHosLocation) {
            throw new \InvalidArgumentException(sprintf('The AlternateHosLocation property can only contain items of \Pcm\StructType\PcmAlternateHosLocation, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->AlternateHosLocation[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Pcm\StructType\PcmAlternateHosLocation|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Pcm\StructType\PcmAlternateHosLocation|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Pcm\StructType\PcmAlternateHosLocation|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Pcm\StructType\PcmAlternateHosLocation|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Pcm\StructType\PcmAlternateHosLocation|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AlternateHosLocation
     */
    public function getAttributeName()
    {
        return 'AlternateHosLocation';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\ArrayType\PcmArrayOfAlternateHosLocation
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
