<?php

namespace Pcm\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfArrayOfCoordinates ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfArrayOfCoordinates
 * @package Pcm
 * @subpackage Arrays
 */
class PcmArrayOfArrayOfCoordinates extends AbstractStructArrayBase
{
    /**
     * The ArrayOfCoordinates
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\ArrayType\PcmArrayOfCoordinates[]
     */
    public $ArrayOfCoordinates;
    /**
     * Constructor method for ArrayOfArrayOfCoordinates
     * @uses PcmArrayOfArrayOfCoordinates::setArrayOfCoordinates()
     * @param \Pcm\ArrayType\PcmArrayOfCoordinates[] $arrayOfCoordinates
     */
    public function __construct(array $arrayOfCoordinates = array())
    {
        $this
            ->setArrayOfCoordinates($arrayOfCoordinates);
    }
    /**
     * Get ArrayOfCoordinates value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\ArrayType\PcmArrayOfCoordinates[]|null
     */
    public function getArrayOfCoordinates()
    {
        return isset($this->ArrayOfCoordinates) ? $this->ArrayOfCoordinates : null;
    }
    /**
     * Set ArrayOfCoordinates value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pcm\ArrayType\PcmArrayOfCoordinates[] $arrayOfCoordinates
     * @return \Pcm\ArrayType\PcmArrayOfArrayOfCoordinates
     */
    public function setArrayOfCoordinates(array $arrayOfCoordinates = array())
    {
        foreach ($arrayOfCoordinates as $arrayOfArrayOfCoordinatesArrayOfCoordinatesItem) {
            // validation for constraint: itemType
            if (!$arrayOfArrayOfCoordinatesArrayOfCoordinatesItem instanceof \Pcm\ArrayType\PcmArrayOfCoordinates) {
                throw new \InvalidArgumentException(sprintf('The ArrayOfCoordinates property can only contain items of \Pcm\ArrayType\PcmArrayOfCoordinates, "%s" given', is_object($arrayOfArrayOfCoordinatesArrayOfCoordinatesItem) ? get_class($arrayOfArrayOfCoordinatesArrayOfCoordinatesItem) : gettype($arrayOfArrayOfCoordinatesArrayOfCoordinatesItem)), __LINE__);
            }
        }
        if (is_null($arrayOfCoordinates) || (is_array($arrayOfCoordinates) && empty($arrayOfCoordinates))) {
            unset($this->ArrayOfCoordinates);
        } else {
            $this->ArrayOfCoordinates = $arrayOfCoordinates;
        }
        return $this;
    }
    /**
     * Add item to ArrayOfCoordinates value
     * @throws \InvalidArgumentException
     * @param \Pcm\ArrayType\PcmArrayOfCoordinates $item
     * @return \Pcm\ArrayType\PcmArrayOfArrayOfCoordinates
     */
    public function addToArrayOfCoordinates(\Pcm\ArrayType\PcmArrayOfCoordinates $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pcm\ArrayType\PcmArrayOfCoordinates) {
            throw new \InvalidArgumentException(sprintf('The ArrayOfCoordinates property can only contain items of \Pcm\ArrayType\PcmArrayOfCoordinates, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ArrayOfCoordinates[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Pcm\ArrayType\PcmArrayOfCoordinates|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Pcm\ArrayType\PcmArrayOfCoordinates|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Pcm\ArrayType\PcmArrayOfCoordinates|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Pcm\ArrayType\PcmArrayOfCoordinates|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Pcm\ArrayType\PcmArrayOfCoordinates|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ArrayOfCoordinates
     */
    public function getAttributeName()
    {
        return 'ArrayOfCoordinates';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\ArrayType\PcmArrayOfArrayOfCoordinates
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
