<?php

namespace Pcm\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfExtendedRoute ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfExtendedRoute
 * @package Pcm
 * @subpackage Arrays
 */
class PcmArrayOfExtendedRoute extends AbstractStructArrayBase
{
    /**
     * The ExtendedRoute
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmExtendedRoute[]
     */
    public $ExtendedRoute;
    /**
     * Constructor method for ArrayOfExtendedRoute
     * @uses PcmArrayOfExtendedRoute::setExtendedRoute()
     * @param \Pcm\StructType\PcmExtendedRoute[] $extendedRoute
     */
    public function __construct(array $extendedRoute = array())
    {
        $this
            ->setExtendedRoute($extendedRoute);
    }
    /**
     * Get ExtendedRoute value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmExtendedRoute[]|null
     */
    public function getExtendedRoute()
    {
        return isset($this->ExtendedRoute) ? $this->ExtendedRoute : null;
    }
    /**
     * Set ExtendedRoute value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmExtendedRoute[] $extendedRoute
     * @return \Pcm\ArrayType\PcmArrayOfExtendedRoute
     */
    public function setExtendedRoute(array $extendedRoute = array())
    {
        foreach ($extendedRoute as $arrayOfExtendedRouteExtendedRouteItem) {
            // validation for constraint: itemType
            if (!$arrayOfExtendedRouteExtendedRouteItem instanceof \Pcm\StructType\PcmExtendedRoute) {
                throw new \InvalidArgumentException(sprintf('The ExtendedRoute property can only contain items of \Pcm\StructType\PcmExtendedRoute, "%s" given', is_object($arrayOfExtendedRouteExtendedRouteItem) ? get_class($arrayOfExtendedRouteExtendedRouteItem) : gettype($arrayOfExtendedRouteExtendedRouteItem)), __LINE__);
            }
        }
        if (is_null($extendedRoute) || (is_array($extendedRoute) && empty($extendedRoute))) {
            unset($this->ExtendedRoute);
        } else {
            $this->ExtendedRoute = $extendedRoute;
        }
        return $this;
    }
    /**
     * Add item to ExtendedRoute value
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmExtendedRoute $item
     * @return \Pcm\ArrayType\PcmArrayOfExtendedRoute
     */
    public function addToExtendedRoute(\Pcm\StructType\PcmExtendedRoute $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pcm\StructType\PcmExtendedRoute) {
            throw new \InvalidArgumentException(sprintf('The ExtendedRoute property can only contain items of \Pcm\StructType\PcmExtendedRoute, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ExtendedRoute[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Pcm\StructType\PcmExtendedRoute|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Pcm\StructType\PcmExtendedRoute|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Pcm\StructType\PcmExtendedRoute|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Pcm\StructType\PcmExtendedRoute|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Pcm\StructType\PcmExtendedRoute|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ExtendedRoute
     */
    public function getAttributeName()
    {
        return 'ExtendedRoute';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\ArrayType\PcmArrayOfExtendedRoute
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
