<?php

namespace Pcm\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfHoursOfServiceLocation ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfHoursOfServiceLocation
 * @package Pcm
 * @subpackage Arrays
 */
class PcmArrayOfHoursOfServiceLocation extends AbstractStructArrayBase
{
    /**
     * The HoursOfServiceLocation
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmHoursOfServiceLocation[]
     */
    public $HoursOfServiceLocation;
    /**
     * Constructor method for ArrayOfHoursOfServiceLocation
     * @uses PcmArrayOfHoursOfServiceLocation::setHoursOfServiceLocation()
     * @param \Pcm\StructType\PcmHoursOfServiceLocation[] $hoursOfServiceLocation
     */
    public function __construct(array $hoursOfServiceLocation = array())
    {
        $this
            ->setHoursOfServiceLocation($hoursOfServiceLocation);
    }
    /**
     * Get HoursOfServiceLocation value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmHoursOfServiceLocation[]|null
     */
    public function getHoursOfServiceLocation()
    {
        return isset($this->HoursOfServiceLocation) ? $this->HoursOfServiceLocation : null;
    }
    /**
     * Set HoursOfServiceLocation value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmHoursOfServiceLocation[] $hoursOfServiceLocation
     * @return \Pcm\ArrayType\PcmArrayOfHoursOfServiceLocation
     */
    public function setHoursOfServiceLocation(array $hoursOfServiceLocation = array())
    {
        foreach ($hoursOfServiceLocation as $arrayOfHoursOfServiceLocationHoursOfServiceLocationItem) {
            // validation for constraint: itemType
            if (!$arrayOfHoursOfServiceLocationHoursOfServiceLocationItem instanceof \Pcm\StructType\PcmHoursOfServiceLocation) {
                throw new \InvalidArgumentException(sprintf('The HoursOfServiceLocation property can only contain items of \Pcm\StructType\PcmHoursOfServiceLocation, "%s" given', is_object($arrayOfHoursOfServiceLocationHoursOfServiceLocationItem) ? get_class($arrayOfHoursOfServiceLocationHoursOfServiceLocationItem) : gettype($arrayOfHoursOfServiceLocationHoursOfServiceLocationItem)), __LINE__);
            }
        }
        if (is_null($hoursOfServiceLocation) || (is_array($hoursOfServiceLocation) && empty($hoursOfServiceLocation))) {
            unset($this->HoursOfServiceLocation);
        } else {
            $this->HoursOfServiceLocation = $hoursOfServiceLocation;
        }
        return $this;
    }
    /**
     * Add item to HoursOfServiceLocation value
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmHoursOfServiceLocation $item
     * @return \Pcm\ArrayType\PcmArrayOfHoursOfServiceLocation
     */
    public function addToHoursOfServiceLocation(\Pcm\StructType\PcmHoursOfServiceLocation $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pcm\StructType\PcmHoursOfServiceLocation) {
            throw new \InvalidArgumentException(sprintf('The HoursOfServiceLocation property can only contain items of \Pcm\StructType\PcmHoursOfServiceLocation, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->HoursOfServiceLocation[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Pcm\StructType\PcmHoursOfServiceLocation|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Pcm\StructType\PcmHoursOfServiceLocation|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Pcm\StructType\PcmHoursOfServiceLocation|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Pcm\StructType\PcmHoursOfServiceLocation|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Pcm\StructType\PcmHoursOfServiceLocation|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string HoursOfServiceLocation
     */
    public function getAttributeName()
    {
        return 'HoursOfServiceLocation';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\ArrayType\PcmArrayOfHoursOfServiceLocation
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
