<?php

namespace Pcm\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for HoursOfServiceBreakDurations StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:HoursOfServiceBreakDurations
 * @package Pcm
 * @subpackage Structs
 */
class PcmHoursOfServiceBreakDurations extends AbstractStructBase
{
    /**
     * The ShortBreakDuration
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var float
     */
    public $ShortBreakDuration;
    /**
     * The EndOfDutyBreakDuration
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var float
     */
    public $EndOfDutyBreakDuration;
    /**
     * The CycleResetBreakDuration
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var float
     */
    public $CycleResetBreakDuration;
    /**
     * Constructor method for HoursOfServiceBreakDurations
     * @uses PcmHoursOfServiceBreakDurations::setShortBreakDuration()
     * @uses PcmHoursOfServiceBreakDurations::setEndOfDutyBreakDuration()
     * @uses PcmHoursOfServiceBreakDurations::setCycleResetBreakDuration()
     * @param float $shortBreakDuration
     * @param float $endOfDutyBreakDuration
     * @param float $cycleResetBreakDuration
     */
    public function __construct($shortBreakDuration = null, $endOfDutyBreakDuration = null, $cycleResetBreakDuration = null)
    {
        $this
            ->setShortBreakDuration($shortBreakDuration)
            ->setEndOfDutyBreakDuration($endOfDutyBreakDuration)
            ->setCycleResetBreakDuration($cycleResetBreakDuration);
    }
    /**
     * Get ShortBreakDuration value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return float|null
     */
    public function getShortBreakDuration()
    {
        return isset($this->ShortBreakDuration) ? $this->ShortBreakDuration : null;
    }
    /**
     * Set ShortBreakDuration value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param float $shortBreakDuration
     * @return \Pcm\StructType\PcmHoursOfServiceBreakDurations
     */
    public function setShortBreakDuration($shortBreakDuration = null)
    {
        if (is_null($shortBreakDuration) || (is_array($shortBreakDuration) && empty($shortBreakDuration))) {
            unset($this->ShortBreakDuration);
        } else {
            $this->ShortBreakDuration = $shortBreakDuration;
        }
        return $this;
    }
    /**
     * Get EndOfDutyBreakDuration value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return float|null
     */
    public function getEndOfDutyBreakDuration()
    {
        return isset($this->EndOfDutyBreakDuration) ? $this->EndOfDutyBreakDuration : null;
    }
    /**
     * Set EndOfDutyBreakDuration value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param float $endOfDutyBreakDuration
     * @return \Pcm\StructType\PcmHoursOfServiceBreakDurations
     */
    public function setEndOfDutyBreakDuration($endOfDutyBreakDuration = null)
    {
        if (is_null($endOfDutyBreakDuration) || (is_array($endOfDutyBreakDuration) && empty($endOfDutyBreakDuration))) {
            unset($this->EndOfDutyBreakDuration);
        } else {
            $this->EndOfDutyBreakDuration = $endOfDutyBreakDuration;
        }
        return $this;
    }
    /**
     * Get CycleResetBreakDuration value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return float|null
     */
    public function getCycleResetBreakDuration()
    {
        return isset($this->CycleResetBreakDuration) ? $this->CycleResetBreakDuration : null;
    }
    /**
     * Set CycleResetBreakDuration value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param float $cycleResetBreakDuration
     * @return \Pcm\StructType\PcmHoursOfServiceBreakDurations
     */
    public function setCycleResetBreakDuration($cycleResetBreakDuration = null)
    {
        if (is_null($cycleResetBreakDuration) || (is_array($cycleResetBreakDuration) && empty($cycleResetBreakDuration))) {
            unset($this->CycleResetBreakDuration);
        } else {
            $this->CycleResetBreakDuration = $cycleResetBreakDuration;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\StructType\PcmHoursOfServiceBreakDurations
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
